import type { FC } from 'react';
import type { UserState } from 'umi';
import { useSelector, Redirect, useLocation } from 'umi';

interface IState {
  user: UserState;
}

const loginPath = '/user/login';

const BaseWrapper: FC = (props) => {
  const location = useLocation();
  const user = useSelector<IState, UserState>((state) => state.user);

  if (!user?.accessToken) {
    // 如果不存在token，判断如果当前页面不是登录页就跳转登录页面
    if (location.pathname !== loginPath) {
      // @ts-ignore
      return <Redirect to={loginPath} />;
    }
  } else {
    // 如果有token，判断如果当前是登录页面，就跳转到home页面
    if (location.pathname === loginPath) {
      // @ts-ignore
      return <Redirect to="/home" />;
    }
  }

  return <>{props.children}</>;
};

export default BaseWrapper;
